Bug 1731209 - [OSP14] large number of interfaces cause slow puppet executions due to fact generation
Summary: [OSP14] large number of interfaces cause slow puppet executions due to fact g...
Keywords:
Status: MODIFIED
Alias: None
Product: Red Hat OpenStack
Classification: Red Hat
Component: openstack-tripleo-heat-templates
Version: 14.0 (Rocky)
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: ---
: ---
Assignee: Alex Schultz
QA Contact: Sasha Smolyak
URL:
Whiteboard:
Depends On: 1726325 1728402 1731210
Blocks: 1711267 1731208
TreeView+ depends on / blocked
 
Reported: 2019-07-18 15:38 UTC by Alex Schultz
Modified: 2020-02-22 04:52 UTC (History)
3 users (show)

Fixed In Version: openstack-tripleo-heat-templates-9.3.1-0.20190513171776.el7ost
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1728402
Environment:
Last Closed:
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Launchpad 1835959 None None None 2019-07-18 15:38:40 UTC
OpenStack gerrit 672048 'None' MERGED Re-Add facter cache for container configurations 2020-02-20 20:48:37 UTC

Description Alex Schultz 2019-07-18 15:38:40 UTC
+++ This bug was initially created as a clone of Bug #1728402 +++

Description of problem:
When a compute node (or controller) has many interfaces (bridges/tun), during the application of updates the puppet processes start thrashing trying to generate the network puppet facts. This affects both facter 2 and facter 3 based systems due to the fact that multiple processes end up trying to execute ip commands to gather the networking facts. This can be worked around by caching the facts for the life of the container-puppet.py (or docker-puppet.py) executions. This affects all versions of TripleO since Ocata. Prior to Ocata, facter 2 is super slow when there are more than than 1000 interfaces on a host. At ~1500, it can take >= 10 minutes to generate the facts.

for i in $(seq 1 380); do ip tuntap add name dummy_tun$i mode tun; done
for i in $(seq 1 1274); do ip link add name dummy_br$i type bridge; done

$ time facter

facter2
real 9m51.817s
user 7m8.936s
sys 2m42.702s

facter3
real 0m2.954s
user 0m1.111s
sys 0m1.721s

$ time puppet facts

facter2
real 12m10.936s
user 8m16.478s
sys 3m54.138s

facter3
real 0m11.169s
user 0m5.522s
sys 0m4.002s


Steps to Reproduce:
1. deploy basic undercloud
2. deploy default overcloud 1ctlr+1compute
3. Apply dummy network interfaces to compute
for i in $(seq 1 380); do ip tuntap add name dummy_tun$i mode tun; done
for i in $(seq 1 1274); do ip link add name dummy_br$i type bridge; done
4. deploy stack update with no configuration changes

Actual results:
Stack update will take an excessive amount of time (almost 4 hours in my test) compared to a basic 1ctlr+1compute update with no interfaces (~30 mins in my test)

Expected results:
Stack update may take a bit longer but it shouldn't approach timeouts.

Comment 1 Alex Schultz 2019-07-18 15:42:37 UTC
It should be noted that OSP14 uses facter2 which will still have a larger delay than with facter3 (osp15+). We are currently investigating upgrading facter as well for this version but this should improve the existing performance.

Comment 2 Emilien Macchi 2019-08-29 14:33:28 UTC
This is a work in progress as you can see in the dependencies being rebased. Moving to ON_DEV. Alex please move it to POST/MODIFIED if you think it's ready. Thanks!


Note You need to log in before you can comment on or make changes to this bug.